diff --git a/data/XFCE b/data/XFCE
index 00c8d00..4d06c05 100644
--- a/data/XFCE
+++ b/data/XFCE
@@ -32,8 +32,7 @@ thunar-thumbnailers
 xfce4-taskmanager
 xfce4-power-manager
 ristretto
-yast2-gtk
-epdfview
+yast2-control-center-gnome
 // #404447
 gtk2-engine-murrine
 // #440285
@@ -41,6 +40,28 @@ pinentry-gtk2
 avahi
 // #537365
 smolt
+gdm
+// use gnomesu as su wrapper
+libgnomesu
+// #540627
+xdg-utils
+xdg-user-dirs-gtk
+NetworkManager
+NetworkManager-gnome
+xscreensaver
+evince
+xfburn
+xfmedia
+xfce4-volumed
+cheese
+empathy
+transmission-gtk
+MozillaThunderbird
+// Recommends patterns to improve user experience
+patterns-openSUSE-xfce_office
+patterns-openSUSE-multimedia
+patterns-openSUSE-imaging
+patterns-openSUSE-remote_desktop
 -Prc:
 +Psg:
 #pragma online
@@ -80,8 +101,6 @@ xfce4-panel-plugin-xfapplet
 xfce4-panel-plugin-xkb
 xfce4-panel-plugin-xmms
 xfce4-panel-plugin-xfmedia-remote
-xfmedia
 xfwm4-themes
 xfce4-vala
-xfce4-volumed
 -Psg:
diff --git a/data/XFCE-LAPTOP b/data/XFCE-LAPTOP
new file mode 100644
index 0000000..995e4f1
--- /dev/null
+++ b/data/XFCE-LAPTOP
@@ -0,0 +1,8 @@
++Prq:
+patterns-openSUSE-xfce_laptop
+-Prq:
+
++Prc:
+gnome-bluetooth
+gsynaptics
+-Prc:
diff --git a/pattern-list.txt b/pattern-list.txt
index da76102..c65d79f 100644
--- a/pattern-list.txt
+++ b/pattern-list.txt
@@ -53,6 +53,11 @@ LXDE Desktop
 lxde_office		LXDE Office
 lxde_laptop		LXDE Laptop
 
+LXDE Desktop
+============
+xfce_office		XFCE Office
+xfce_laptop		XFCE Laptop
+
 Desktop Functions
 =================
 games:			Games
diff --git a/toinstall/xfce/recommends b/toinstall/xfce/recommends
new file mode 100644
index 0000000..6cd18fe
--- /dev/null
+++ b/toinstall/xfce/recommends
@@ -0,0 +1 @@
+xfce_office
diff --git a/toinstall/xfce_laptop/category b/toinstall/xfce_laptop/category
new file mode 100644
index 0000000..2d6f263
--- /dev/null
+++ b/toinstall/xfce_laptop/category
@@ -0,0 +1 @@
+laptop
diff --git a/toinstall/xfce_laptop/extends b/toinstall/xfce_laptop/extends
new file mode 100644
index 0000000..2d6f263
--- /dev/null
+++ b/toinstall/xfce_laptop/extends
@@ -0,0 +1 @@
+laptop
diff --git a/toinstall/xfce_laptop/freshens b/toinstall/xfce_laptop/freshens
new file mode 100644
index 0000000..8c4ca0c
--- /dev/null
+++ b/toinstall/xfce_laptop/freshens
@@ -0,0 +1 @@
+xfce
diff --git a/toinstall/xfce_laptop/icon b/toinstall/xfce_laptop/icon
new file mode 100644
index 0000000..74666f9
--- /dev/null
+++ b/toinstall/xfce_laptop/icon
@@ -0,0 +1 @@
+pattern-generic
diff --git a/toinstall/xfce_laptop/order b/toinstall/xfce_laptop/order
new file mode 100644
index 0000000..386b0a3
--- /dev/null
+++ b/toinstall/xfce_laptop/order
@@ -0,0 +1 @@
+5180
diff --git a/toinstall/xfce_laptop/requires b/toinstall/xfce_laptop/requires
new file mode 100644
index 0000000..8c4ca0c
--- /dev/null
+++ b/toinstall/xfce_laptop/requires
@@ -0,0 +1 @@
+xfce
diff --git a/toinstall/xfce_laptop/role b/toinstall/xfce_laptop/role
new file mode 100644
index 0000000..9dc3d50
--- /dev/null
+++ b/toinstall/xfce_laptop/role
@@ -0,0 +1 @@
+XFCE Desktop
diff --git a/toinstall/xfce_laptop/sel b/toinstall/xfce_laptop/sel
new file mode 100644
index 0000000..b8c5cbd
--- /dev/null
+++ b/toinstall/xfce_laptop/sel
@@ -0,0 +1 @@
+XFCE-LAPTOP
diff --git a/toinstall/xfce_laptop/supplements b/toinstall/xfce_laptop/supplements
new file mode 100644
index 0000000..2d6f263
--- /dev/null
+++ b/toinstall/xfce_laptop/supplements
@@ -0,0 +1 @@
+laptop
diff --git a/toinstall/xfce_laptop/visible b/toinstall/xfce_laptop/visible
new file mode 100644
index 0000000..c508d53
--- /dev/null
+++ b/toinstall/xfce_laptop/visible
@@ -0,0 +1 @@
+false
diff --git a/data/XFCE b/data/XFCE
index 00c8d00..25123b3 100644
--- a/data/XFCE
+++ b/data/XFCE
@@ -31,9 +31,10 @@ thunar-media-tags-plugin
 thunar-thumbnailers
 xfce4-taskmanager
 xfce4-power-manager
+totem
+totem-browser-plugin
 ristretto
-yast2-gtk
-epdfview
+yast2-control-center-gnome
 // #404447
 gtk2-engine-murrine
 // #440285
@@ -41,6 +42,27 @@ pinentry-gtk2
 avahi
 // #537365
 smolt
+gdm
+// use gnomesu as su wrapper
+libgnomesu
+// #540627
+xdg-utils
+xdg-user-dirs-gtk
+NetworkManager
+NetworkManager-gnome
+xscreensaver
+evince
+xfburn
+xfce4-volumed
+cheese
+empathy
+transmission-gtk
+MozillaThunderbird
+// Recommends patterns to improve user experience
+patterns-openSUSE-xfce_office
+patterns-openSUSE-multimedia
+patterns-openSUSE-imaging
+patterns-openSUSE-remote_desktop
 -Prc:
 +Psg:
 #pragma online
@@ -83,5 +105,4 @@ xfce4-panel-plugin-xfmedia-remote
 xfmedia
 xfwm4-themes
 xfce4-vala
-xfce4-volumed
 -Psg:
diff --git a/data/XFCE-LAPTOP b/data/XFCE-LAPTOP
new file mode 100644
index 0000000..995e4f1
--- /dev/null
+++ b/data/XFCE-LAPTOP
@@ -0,0 +1,8 @@
++Prq:
+patterns-openSUSE-xfce_laptop
+-Prq:
+
++Prc:
+gnome-bluetooth
+gsynaptics
+-Prc:
diff --git a/pattern-list.txt b/pattern-list.txt
index da76102..c65d79f 100644
--- a/pattern-list.txt
+++ b/pattern-list.txt
@@ -53,6 +53,11 @@ LXDE Desktop
 lxde_office		LXDE Office
 lxde_laptop		LXDE Laptop
 
+LXDE Desktop
+============
+xfce_office		XFCE Office
+xfce_laptop		XFCE Laptop
+
 Desktop Functions
 =================
 games:			Games
diff --git a/toinstall/xfce/recommends b/toinstall/xfce/recommends
new file mode 100644
index 0000000..6cd18fe
--- /dev/null
+++ b/toinstall/xfce/recommends
@@ -0,0 +1 @@
+xfce_office
diff --git a/toinstall/xfce_laptop/category b/toinstall/xfce_laptop/category
new file mode 100644
index 0000000..2d6f263
--- /dev/null
+++ b/toinstall/xfce_laptop/category
@@ -0,0 +1 @@
+laptop
diff --git a/toinstall/xfce_laptop/extends b/toinstall/xfce_laptop/extends
new file mode 100644
index 0000000..2d6f263
--- /dev/null
+++ b/toinstall/xfce_laptop/extends
@@ -0,0 +1 @@
+laptop
diff --git a/toinstall/xfce_laptop/freshens b/toinstall/xfce_laptop/freshens
new file mode 100644
index 0000000..8c4ca0c
--- /dev/null
+++ b/toinstall/xfce_laptop/freshens
@@ -0,0 +1 @@
+xfce
diff --git a/toinstall/xfce_laptop/icon b/toinstall/xfce_laptop/icon
new file mode 100644
index 0000000..74666f9
--- /dev/null
+++ b/toinstall/xfce_laptop/icon
@@ -0,0 +1 @@
+pattern-generic
diff --git a/toinstall/xfce_laptop/order b/toinstall/xfce_laptop/order
new file mode 100644
index 0000000..386b0a3
--- /dev/null
+++ b/toinstall/xfce_laptop/order
@@ -0,0 +1 @@
+5180
diff --git a/toinstall/xfce_laptop/requires b/toinstall/xfce_laptop/requires
new file mode 100644
index 0000000..8c4ca0c
--- /dev/null
+++ b/toinstall/xfce_laptop/requires
@@ -0,0 +1 @@
+xfce
diff --git a/toinstall/xfce_laptop/role b/toinstall/xfce_laptop/role
new file mode 100644
index 0000000..9dc3d50
--- /dev/null
+++ b/toinstall/xfce_laptop/role
@@ -0,0 +1 @@
+XFCE Desktop
diff --git a/toinstall/xfce_laptop/sel b/toinstall/xfce_laptop/sel
new file mode 100644
index 0000000..b8c5cbd
--- /dev/null
+++ b/toinstall/xfce_laptop/sel
@@ -0,0 +1 @@
+XFCE-LAPTOP
diff --git a/toinstall/xfce_laptop/supplements b/toinstall/xfce_laptop/supplements
new file mode 100644
index 0000000..2d6f263
--- /dev/null
+++ b/toinstall/xfce_laptop/supplements
@@ -0,0 +1 @@
+laptop
diff --git a/toinstall/xfce_laptop/visible b/toinstall/xfce_laptop/visible
new file mode 100644
index 0000000..c508d53
--- /dev/null
+++ b/toinstall/xfce_laptop/visible
@@ -0,0 +1 @@
+false